new Vue({
    el:'#app',
    data() {
        return {
            questionNum: 0,
            questionList: [],
            currentQuestion: [],
            nextFlag: true
        }
        
    },
    mounted() {
        this.PXTOREM(document, window);
        window['nextQuestion'] = val => {
            this.nextQuestion()
        };
        window['getQuestionList'] = val => {
            this.getQuestionList(val)
        };
        window['inputAnswer'] = val => {
            this.inputAnswer(val)
        };

    },
    methods:{
        //rem 换算
        PXTOREM(doc, win){
            var docEl = doc.documentElement,
            resizeEvt = 'orientationchange' in window ? 'orientationchange' : 'resize',
            recalc = function () {
                window.clientWidth = docEl.clientWidth;
                if (!window.clientWidth) return;
                docEl.style.fontSize = 37.5 * (window.clientWidth / 375) + 'px';
                window.base = 37.5 * (window.clientWidth / 375);
            };
            recalc();
            if (!doc.addEventListener) return;
            win.addEventListener(resizeEvt, recalc, false);
            doc.addEventListener('DOMContentLoaded', recalc, false);
        },
        //获取数据
        getQuestionList(list){
            this.questionList =JSON.parse(list);
            this.currentQuestion.push(this.questionList[this.questionNum]);
            this.$nextTick(() => {
                 let actionWidth = document.getElementById('actions').clientWidth;
                 let itemWidth = document.getElementById('item').clientWidth;//屏幕实际宽度
                 if(actionWidth < itemWidth){
                     document.getElementById('item').setAttribute('style','text-align:center');
                 }else{                    
                    document.getElementById('item').setAttribute('style','');
                 }
              })
        },
        //获取app答案
        inputAnswer(val){
            if(!this.nextFlag){
              return;
            }
            //用户输入的答案和正确答案一致后再判断是否正确
            let currentDom;
            if(this.$refs.action[0].className == 'fractionContent'){
            //有分数
              let dom = this.$refs.action[0].children;
                for(let i=0; i<dom.length; i++){
                 if(dom[i].className == 'frame') currentDom = dom[i]
                 }
            }else{
                currentDom = this.$refs.action[0].children[0];
            }
            let answer = val.toString();
            if(answer.length >= this.questionList[this.questionNum].answer.length || answer.indexOf('/') != -1){
                this.nextFlag = false;
                if(this.questionList[this.questionNum].answer == answer){
                  console.log('answer:'+answer)
                    //作对
                    if(answer.indexOf('**') > -1){
                        let answerArr = answer.split('**');
                        let answerArr1 = answerArr[1].split('/');
                        currentDom.innerHTML = `<div class="algebra">
                                                    <h2>${answerArr[0]}</h2>
                                                    <div class="math">
                                                        <h3>${answerArr1[0]}</h3>
                                                        <p></p>
                                                        <h4>${answerArr1[1]}</h4>
                                                    </div>
                                                </div>`
                    }else{
                        answer = val.replace(new RegExp("错",'g'),"×");
                        answer = answer.replace(new RegExp("对",'g'),"✓");
                        currentDom.innerHTML = `<span>${answer}</span>`;
                    }
                     ZjxAndroidWebView.JSCorrectData(this.questionList[this.questionNum].id)
                }else{
                    //作错
                    if(answer.indexOf('**') > -1){
                        let answerArr = answer.split('**');
                        let answerArr1 = answerArr[1].split('/');
                        currentDom.innerHTML = `<div class="error">
                                                    <div class="algebra">
                                                        <h2>${answerArr[0]}</h2>
                                                        <div class="math">
                                                            <h3>${answerArr1[0]}</h3>
                                                            <p></p>
                                                            <h4>${answerArr1[1]}</h4>
                                                        </div>
                                                    </div> 
                                                </div>`
                    }else{
                         answer = val.replace(new RegExp("错",'g'),"×");
                         answer = answer.replace(new RegExp("对",'g'),"✓");
                        currentDom.innerHTML = `<div class="error">${answer}</div>`;
                    }
                      ZjxAndroidWebView.JSErrorData(this.questionList[this.questionNum].id)
                }
                setTimeout(function() {
                    nextQuestion();
                }, 2000);
            }else{
                if(answer.indexOf('**') > -1){
                    let answerArr = answer.split('**');
                    let answerArr1 = answerArr[1].split('/');
                    currentDom.innerHTML = `<div class="algebra">
                                                <h2>${answerArr[0]}</h2>
                                                <div class="math">
                                                    <h3>${answerArr1[0]}</h3>
                                                    <p></p>
                                                    <h4>${answerArr1[1]}</h4>
                                                </div>
                                            </div>`
                }else{
                    answer = val.replace(new RegExp("错",'g'),"×");
                    answer = answer.replace(new RegExp("对",'g'),"✓");
                    currentDom.innerHTML = `<span>${answer}</span>`;
                }
            }
        },
        //下一题
        nextQuestion(){
            if(this.questionNum == this.questionList.length-1){
                //完成
                ZjxAndroidWebView.getCompleteData("finish")
                return
            }
            this.questionNum += 1;
            this.currentQuestion = [];
            this.currentQuestion.push(this.questionList[this.questionNum]);
            this.nextFlag = true;
            ZjxAndroidWebView.getTitleData(this.questionNum+1);
            this.$nextTick(() => {
                             let actionWidth = document.getElementById('actions').clientWidth;
                             let itemWidth = document.getElementById('item').clientWidth;//屏幕实际宽度
                             if(actionWidth < itemWidth){
                                 document.getElementById('item').setAttribute('style','text-align:center');
                             }else{                    
                                document.getElementById('item').setAttribute('style','');
                             }
                          })
        },
        //习题解析
        cardingQuestion(content){
            let tag = [ '**' ];
            for (let i = 0; i < tag.length; i++) {
                let arr = content.split(tag[i]);
                if(arr.length > 1){
                    for (let j = 0; j < arr.length; j++) {
                        if(arr[j].indexOf('/') > -1){
                            let aa = arr[j].split('/');
                            let startText = aa[0];
                            let endText = aa[1];
                            arr[j] = `<div class="math">
                                        <h3>${startText}</h3>
                                        <p></p>
                                        <h4>${endText}</h4>   
                                      </div>`
                        }else{
                            if(arr[j].indexOf('$$') > -1){
                                // 有 input	
                                arr[j] = arr[j].replace(/\$\$/g, '<div class="frame"></div>');
                            }else if(content.indexOf('&$') > -1){
                                arr[j] = arr[j].replace(/\&\$/g, '<div class="circular"></div>');
                            }else if(content.indexOf('#$') > -1){
                                arr[j] = arr[j].replace(/\#\$/g, '<div class="underline"></div>');
                            }
                        }
                    }
                    content = arr.join('');
                }else{
                    if(content.indexOf('$$') > -1){
                        // 有 input	
                        content = content.replace(/\$\$/g, '<div class="frame"></div>');
                    }else if(content.indexOf('&$') > -1){
                        content = content.replace(/\&\$/g, '<div class="circular"></div>');
                    }else if(content.indexOf('#$') > -1){
                        content = content.replace(/\#\$/g, '<div class="underline"></div>');
                    }
                }
            }
            
            return content
        }
    },
}) 
